@echo off
setlocal

REM *************************************************************************
REM Post OS Unattend Update batch file for NT 4.0
REM
REM This batch file updates the 570x drivers and the registry for NT 4.0.
REM *************************************************************************

REM *************************************************************************
REM Possible invocations:
REM B57NT4UD <SrcPath> <Reboot>   - specify absolute path to source files and
REM                                 reboot option
REM B57NT4UD <Reboot>             - use current directory and specify reboot
REM                                 option
REM B57NT4UD                      - use current directory; reboot option
REM                                 defaults to no reboot
REM *************************************************************************

if (%1) == ?  goto usage

REM *************************************************************************
REM Set environment variables default value.
REM *************************************************************************
set B57NT4UDCURDIR=
set SRCPATH=
set INFSECTION=B57NT4
set REBOOTOPT=
set logFile=%computername%_%INFSECTION%

REM *************************************************************************
REM Get command line option(s).
REM *************************************************************************
B57Path.exe
if errorlevel 1 goto LogError
call %systemroot%\system32\B57Path.bat
del %systemroot%\system32\B57Path.bat /q >nul 2>>&1
if (%2) == () goto parse1
set SRCPATH=%2
set REBOOTOPT=%1
goto CheckReboot

:parse1
if (%1) == () goto parse0
set SRCPATH=%B57NT4UDCURDIR%
set REBOOTOPT=%1
goto CheckReboot

:parse0
set SRCPATH=%B57NT4UDCURDIR%
set REBOOTOPT=0

:CheckReboot
REM *************************************************************************
REM Check reboot option
REM *************************************************************************
if %REBOOTOPT% == 0  goto DoUpdate
if %REBOOTOPT% == 1  goto DoUpdate
if %REBOOTOPT% == 2  goto DoUpdate
goto usage

:DoUpdate
REM *************************************************************************
REM Do the update.
REM *************************************************************************
%systemdrive%
cd %systemroot%\system32
setup /f /i %B57NT4UDCURDIR%\B57NT4UD.inf /T NTN_SRCPATH = %SRCPATH%\ /T NTN_Infname = OEMSETUP.INF /T NTN_RegBase = "SOFTWARE\Microsoft\Windows NT\CurrentVersion\NetworkCards\1" /T NTN_InstallMode = update /T NTN_Origination = install /T NTN_InfOption = %INFSECTION%

REM *************************************************************************
REM Log result.
REM *************************************************************************
:LogError
echo %errorLevel% > %systemroot%\system32\%logFile%.log
if errorlevel 1 goto RegError

REM *************************************************************************
REM Set HKEY_LOCAL_MACHINE\SOFTWARE\Broadcom\B57NT4\Unattended Update =
REM "Pass" or "Fail"
REM *************************************************************************
%B57NT4UDCURDIR%\B57Path.exe Pass
goto RebootOption

:RegError
%B57NT4UDCURDIR%\B57Path.exe Fail
goto end

:RebootOption
REM *************************************************************************
REM Handle the reboot option
REM *************************************************************************
if %REBOOTOPT%==0 goto end
if %REBOOTOPT%==1 goto DoReboot
if %REBOOTOPT%==2 goto DoReboot
goto end

:DoReboot
REM *************************************************************************
REM Create a bogus INF file
REM *************************************************************************
echo [Version] > %TEMP%\reboot.inf
echo Signature="$Windows NT$" >> %TEMP%\reboot.inf
echo Provider="Broadcom" >> %TEMP%\reboot.inf
echo [Install] >> %TEMP%\reboot.inf

rundll32 setupapi.dll,InstallHinfSection Strings %REBOOTOPT% %TEMP%\reboot.inf
del %TEMP%\reboot.inf /q >nul 2>>&1

goto end

REM *************************************************************************
REM Display the usage
REM *************************************************************************
:usage
echo+
echo Usage: B57NT4UD [RebootOption [SourcePath]]
echo+
echo        SourcePath   : absolute path to the driver files
echo                       default is the current directory
echo+
echo        RebootOption : 0 no reboot  - default
echo                       1 reboot the machine without prompting the user
echo                       2 reboot the machine by prompting the user
echo+
echo        Examples:  B57NT4UD 0 c:\driver
echo                   B57NT4UD 1
echo                   B57NT4UD

:end

endlocal
@echo on
